//fixed deposit section

function fixed_deposit()
{
   oWin       = new Form    ( "Fixed Deposit Section", 700, 500);
   oLabel1    = new Label   ( oWin, 30, 10, "Interest Compounding" );
   oCombo1    = new ComboBox( oWin, 30, 200, [ "Daily", "Monthly", "Quarterly", "Half-yearly", "Yearly" ],  [ "Daily", "Monthly", "Quarterly", "Half-yearly", "Yearly" ],
                                  0 );
   oTextBox1  = new TextBox ( oWin, 70, 200, '' );
   oTextBox2  = new TextBox ( oWin, 110, 200, '' );
   oLabel2    = new Label   ( oWin, 110, 360, '% p.a.' );
   oTextBox3  = new TextBox ( oWin, 150, 200, '' );
   oCombo2    = new ComboBox( oWin, 150, 360, 
                                  [ "Days", "Months", "Quarters", "Half Years", "Years" ],
                                  [ "Days", "Months", "Quarters", "Half Years", "Years" ],
                                  0 );
   oTextBox4  = new TextBox ( oWin, 190, 200, '' );
   oButton1   = new Button  ( oWin, 70, 10, 'Deposit Amount', "fd_principal()" );
   oButton2   = new Button  ( oWin, 110, 10, 'Interest Rate', "fd_intrate()" );
   oButton3   = new Button  ( oWin, 150, 10, 'Term', "fd_term()" );
   oButton4   = new Button  ( oWin, 190, 10, 'Maturity Value', "fd_maturity()" );
   oGrid1     = new Grid    ( oWin, 230, 10, 680, 210, [ "     ", "Opening Balance", "Interest", "Closing Balance" ], 640 );
   oButton5   = new Button  ( oWin, 450, 150, "Close", "oWin.release()" );
   oButton6   = new Button  ( oWin, 450, 300, "Reset", "fdreset()" );
   
   oTextBox1.setJustify( 'right' );
   oTextBox2.setJustify( 'right' );
   oTextBox3.setJustify( 'right' );
   oTextBox4.setJustify( 'right' );
   oTextBox1.setNumericMask( 14, 2, '.', '', false );
   oTextBox2.setNumericMask( 3, 2, '.', '', false );
   oTextBox3.setNumericMask( 5, 0, '.', '', false );
   oTextBox4.setNumericMask( 14, 2, '.', '', false );
   
}

function fdreset()
{
   oTextBox1.setValue( '' );
   oTextBox2.setValue( '' );
   oTextBox3.setValue( '' );
   oTextBox4.setValue( '' );
   count = oGrid1.getRowCount();
   for( i = count - 1; i > 0; i-- )
   {
      oGrid1.deleteRow( i );
   }
   document.getElementById( oTextBox1.getId() ).select()
}   

function fd_principal()
{
   initial     = 0.0;
   intrate     = parseFloat( oTextBox2.getValue() ) / 100;
   period      = parseFloat( oTextBox3.getValue() );
   maturity    = parseFloat( oTextBox4.getValue() );
   intarr2 = [ 360, 12, 4, 2, 1 ];
   yearlycompoundings = intarr2[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr2[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox2.isValid() ) 
   {
      alert( 'Interest Rate should be correctly entered!' );
      document.getElementById( oTextBox2.getId() ).select();
      return;
   }
      
   if ( !oTextBox3.isValid() ) 
   {
      alert( 'Term should be correctly entered!' );
      document.getElementById( oTextBox3.getId() ).select();
      return;
   }
      
   if ( !oTextBox4.isValid() ) 
   {
      alert( 'Maturity Value should be correctly entered!' );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }
   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlyinstalments;// rate per yearlyinstalments
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
      balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      initial = maturity;
      initial = initial / ( 1 + ( m * balacomp ) );
      initial = initial / Math.pow( ( 1 + ( intrate / yearlycompoundings ) ), fulcomp );
      initial = ( initial ).toFixed( 2 );
      oTextBox1.setValue( ( initial ).toString() );
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      m = intrate / yearlycompoundings;
      initial = maturity / Math.pow( ( 1 + m ), ( period / yearlyinstalments * yearlycompoundings ) )
      initial = ( initial ).toFixed( 2 );
      oTextBox1.setValue( ( initial ).toString() );
   }   
   showfdaccount();
}

function fd_intrate()
{
   initial = parseFloat( oTextBox1.getValue() );
   intrate = 0.0;
   period = parseFloat( oTextBox3.getValue() );
   maturity = parseFloat( oTextBox4.getValue() );
   intarr2 = [ 360, 12, 4, 2, 1 ];
   yearlycompoundings = intarr2[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr2[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox1.isValid() ) 
   {
      alert( 'Initial Deposit Amount should be correctly entered!' );
      document.getElementById( oTextBox1.getId() ).select();
      return;
   }
      
   if ( !oTextBox3.isValid() ) 
   {
      alert( 'Term should be correctly entered!' );
      document.getElementById( oTextBox3.getId() ).select();
      return;
   }
      
   if ( !oTextBox4.isValid() ) 
   {
      alert( 'Maturity Value should be correctly entered!' );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }
   if ( maturity <= initial )
   {
      alert( "Maturity amount MUST be greater than the amount invested." );
      return;
   }   
   if ( yearlyinstalments >= yearlycompoundings )
   {
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
      balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      if ( fulcomp > 0 )
      {
         m = Math.pow( ( maturity / initial), (1 / fulcomp)) - 1;
         intrate = m * yearlycompoundings;
         if ( balacomp > 0 )
         {
            crossed = false;
            while ( !crossed )
            {
               m = intrate / yearlyinstalments;
               if ( ( initial * Math.pow( ( 1 + ( intrate / yearlycompoundings ) ), fulcomp ) ) * ( 1 + ( m * balacomp ) ) <= maturity )
               {
                  crossed = true;
               }   
               else
               {
                  intrate = intrate - 0.000001;
               }   
            }   
         }   
      }   
      else
      {
         if ( balacomp > 0 )
         {
            intrate = 0.000001;
            crossed = false;
            while ( !crossed )
            {
               m = intrate / yearlyinstalments;
               if ( ( initial * ( 1 + ( m * balacomp ) ) ) >= maturity )
               {
                  crossed = true;
               }   
               else
               {
                  intrate = intrate + 0.000001;
               }   
            }
         }
      }         
      intrate = ( intrate * 100 ).toFixed( 2 );
      oTextBox2.setValue( ( intrate ).toString() );
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      x = ( period / yearlyinstalments * yearlycompoundings );
      m = Math.pow( ( ( maturity / initial ), ( 1 / x ) ) ) - 1;
      intrate = ( intrate * 100 ).toFixed( 2 );
      oTextBox2.setValue( ( intrate ).toString() );
   }   
   showfdaccount();
}

function fd_term()
{

   initial = parseFloat( oTextBox1.getValue() );
   intrate = parseFloat( oTextBox2.getValue() / 100 );
   period = 0;
   maturity = parseFloat( oTextBox4.getValue() );
   intarr2 = [ 360, 12, 4, 2, 1 ];
   yearlycompoundings = intarr2[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr2[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox1.isValid() ) 
   {
      alert( 'Initial Deposit Amount should be correctly entered!' );
      document.getElementById( oTextBox1.getId() ).select();
      return;
   }
      
   if ( !oTextBox2.isValid() ) 
   {
      alert( 'Interest Rate should be correctly entered!' );
      document.getElementById( oTextBox2.getId() ).select();
      return;
   }
      
   if ( !oTextBox4.isValid() ) 
   {
      alert( 'Maturity Value should be correctly entered!' );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }
   
   if ( maturity <= initial )
   {
      alert( "Maturity amount MUST be greater than the amount invested." );
      return;
   }   
   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlycompoundings;// rate per yearlyinstalments
      x = ( Math.log( maturity ) - Math.log( initial ) ) / Math.log( ( 1 + m ) );
      period = parseInt( x ) / yearlycompoundings * yearlyinstalments;
      if ( x - parseInt( x ) > 0.0 )
      {
         maturity1 =  initial * Math.pow( ( 1 + ( intrate / yearlycompoundings ) ), parseInt( x ) ); 
         n = ( ( maturity / maturity1 ) - 1 ) / ( intrate / yearlyinstalments );
         period = period + n;
      }
      period = ( period ).toFixed( 0 );
      oTextBox3.setValue( ( period ).toString() );
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      m = intrate / yearlycompoundings;
      x = ( Math.log( maturity ) - Math.log( initial ) ) / Math.log( ( 1 + m ) );
      period = x / yearlycompoundings * yearlyinstalments;
      period = ( period ).toFixed( 0 );
      oTextBox3.setValue( ( period ).toString() );
   }   
   showfdaccount();
}

function fd_maturity()
{
   initial = parseFloat( oTextBox1.getValue() );
   intrate = parseFloat( oTextBox2.getValue() / 100 );
   period = parseFloat( oTextBox3.getValue() );
   maturity = 0.0;
   intarr2 = [ 360, 12, 4, 2, 1 ];
   yearlycompoundings = intarr2[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr2[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox1.isValid() ) 
   {
      alert( 'Initial Deposit Amount should be correctly entered!' );
      document.getElementById( oTextBox1.getId() ).select();
      return;
   }
      
   if ( !oTextBox2.isValid() ) 
   {
      alert( 'Interest Rate should be correctly entered!' );
      document.getElementById( oTextBox2.getId() ).select();
      return;
   }
      
   if ( !oTextBox3.isValid() ) 
   {
      alert( 'Term should be correctly entered!' );
      document.getElementById( oTextBox3.getId() ).select();
      return;
   }

   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlyinstalments;// rate per yearlyinstalments
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
      balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      maturity = initial * Math.pow( ( 1 + ( intrate / yearlycompoundings ) ), fulcomp ) * ( 1 + ( m * balacomp ) );
      maturity = ( maturity ).toFixed( 2 );
      oTextBox4.setValue( ( maturity ).toString() );
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      m = intrate / yearlycompoundings;
      maturity = initial * Math.pow( ( 1 + m ), ( period / yearlyinstalments * yearlycompoundings ) );
      maturity = ( maturity ).toFixed( 2 );
      oTextBox4.setValue( ( maturity ).toString() );
   }      
   showfdaccount();
}

function showfdaccount()
{

   intarr2 = [ 360, 12, 4, 2, 1 ];
   termarr1 = [ "Day", "Month", "Quarter", "Half Year", "Year" ];
   initial = parseFloat( oTextBox1.getValue() );
   intrate = parseFloat( oTextBox2.getValue() ) / 100;
   period = parseFloat( oTextBox3.getValue() );
   roundby = 2;
   maturity = parseFloat( oTextBox4.getValue() );
   yearlycompoundings = intarr2[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr2[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   total1 = 0.0;
   total2 = 0.0;
   count = oGrid1.getRowCount();
   for( i = count - 1; i > 0; i-- )
   {
      oGrid1.deleteRow( i );
   }
   reportarr = [];
   
   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlyinstalments;// rate per yearlyinstalments
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
      balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      oGrid1.setCell( 0, 1, termarr1[ oCombo1.getSelectedIndex() ] );
      counter = 1;
      count1 = 1;
      balance = initial;
      totint = 0;
      totinst = 0;
      product = 0;
      interest = 0;
      while ( counter <= period )
      {
         product = product + balance;
         if ( counter % ( yearlyinstalments / yearlycompoundings ) == 0 )
         {
            interest = ( product * m );
            totint = interest + totint;
            product = 0.0;
         }
         if ( counter > ( fulcomp / yearlycompoundings * yearlyinstalments ) )
         {
            product = 0;
            while ( count1 <= balacomp )
            {
               product = product + balance;
               if ( counter == period )
               {
                  interest = product * m;
                  totint = interest + totint;
                  product = 0;
               }
               if ( interest > 0.0 )
               {
                  oGrid1.addRow( [ ( counter ).toFixed( 0 ).toString(),
                          ( balance ).toFixed( roundby ).toString(),
                          ( interest ).toFixed( roundby ).toString(),
                          ( balance + interest ).toFixed( roundby ).toString() ] );
                  balance = balance + interest;
               }
               count1 = count1 + 1;
               counter = counter + 1;
               interest = 0.0;
            }
         }
         if ( counter <= ( fulcomp / yearlycompoundings * yearlyinstalments ) )
         { 
            if ( interest > 0.0 )
            {
               oGrid1.addRow( [ ( counter ).toFixed( 0 ).toString(),
                       ( balance ).toFixed( roundby ).toString(),
                       ( interest ).toFixed( roundby ).toString(),
                       ( balance + interest ).toFixed( roundby ).toString() ] );
               balance = balance + interest;
            }
            counter = counter + 1;
            interest = 0.0;
         }
      }   
   }
   if ( yearlyinstalments < yearlycompoundings )
   {
      m = intrate / yearlycompoundings;  // rate per compounding period
      n = (yearlycompoundings/yearlyinstalments);
      oGrid1.setCell( 0, 1, termarr1[ oCombo1.getSelectedIndex() ] );
      counter = 1;
      count1 = 1;
      instal1 = 0.0;
      balance = initial;
      totint = 0.0;
      totinst = 0.0;
      product = 0.0;
      interest = 0.0;
      comcount = 1;
      while ( counter <= period * yearlycompoundings / yearlyinstalments )
      {
         product = balance + product;
         interest = product * m;
         totint = totint + interest;
         product = 0.0;
         if ( interest > 0.0 )
         {
            oGrid1.addRow( [ ( counter ).toFixed( 0 ).toString(),
                    ( balance ).toFixed( roundby ).toString(),
                    ( interest ).toFixed( roundby ).toString(),
                    ( balance + interest ).toFixed( roundby ).toString() ] );
            balance = balance + interest;
         }
         counter = counter + 1;
         interest = 0.0;
      }
   }
   oGrid1.setJustify( [ 'right', 'right', 'right', 'right' ] );
}

