// Loan Section

function loan()
{
   oWin       = new Form    ( "Loan Section", 700, 500);
   oLabel1    = new Label   ( oWin, 30, 10, "Interest Compounding" );
   oCombo1    = new ComboBox( oWin, 30, 200, [ "Monthly", "Quarterly", "Half yearly", "Yearly" ],  [ "Monthly", "Quarterly", "Half yearly", "Yearly" ],
                                  0 );
   oTextBox1  = new TextBox ( oWin, 70, 200, '' );
   oTextBox2  = new TextBox ( oWin, 110, 200, '' );
   oLabel2    = new Label   ( oWin, 110, 360, '% p.a.' );
   oTextBox3  = new TextBox ( oWin, 150, 200, '' );
   oCombo2    = new ComboBox( oWin, 150, 360, 
                                  [ "Months", "Quarters", "Half Years", "Years" ],
                                  [ "Months", "Quarters", "Half Years", "Years" ],
                                  0 );
   oTextBox4  = new TextBox ( oWin, 190, 200, '' );
   oButton1   = new Button  ( oWin, 70, 10, 'Principal', "loan_principal()" );
   oButton2   = new Button  ( oWin, 110, 10, 'Interest Rate', "loan_intrate()" );
   oButton3   = new Button  ( oWin, 150, 10, 'Term', "loan_term()" );
   oButton4   = new Button  ( oWin, 190, 10, 'Instalment', "loan_instalment()" );
   oGrid1     = new Grid    ( oWin, 230, 10, 680, 210, [ "     ", "Opening Balance", "Interest Charged", "Repayment", "Closing Balance" ], 640 );
   oButton5   = new Button  ( oWin, 450, 150, "Close", "oWin.release()" );
   oButton6   = new Button  ( oWin, 450, 300, "Reset", "loanreset()" );
   
   oTextBox1.setJustify( 'right' );
   oTextBox2.setJustify( 'right' );
   oTextBox3.setJustify( 'right' );
   oTextBox4.setJustify( 'right' );
   
   oTextBox1.setNumericMask( 14, 2, '.', '', false );
   oTextBox2.setNumericMask( 3, 2, '.', '', false );
   oTextBox3.setNumericMask( 5, 0, '.', '', false );
   oTextBox4.setNumericMask( 14, 2, '.', '', false );
   
}

function loanreset()
{
   oTextBox1.setValue( '' );
   oTextBox2.setValue( '' );
   oTextBox3.setValue( '' );
   oTextBox4.setValue( '' );
   count = oGrid1.getRowCount();
   for( i = count - 1; i > 0; i-- )
   {
      oGrid1.deleteRow( i );
   }
   document.getElementById( oTextBox1.getId() ).select()
}   

function loan_principal()
{
   nIntRate    = parseFloat( oTextBox2.getValue() );
   nTerm       = parseFloat( oTextBox3.getValue() );
   nInstalment = parseFloat( oTextBox4.getValue() );
   intarr1 = [ 12, 4, 2, 1 ];
   
   if ( !oTextBox2.isValid() ) 
   {
      alert( 'Interest Rate should be correctly entered!' );
      oTextBox2.setFocus();
      return;
   }
      
   if ( !oTextBox3.isValid() ) 
   {
      alert( 'Term should be correctly entered!' );
      document.getElementById( oTextBox3.getId() ).select();
      return;
   }
      
   if ( !oTextBox4.isValid() ) 
   {
      alert( 'Instalment should be correctly entered!' );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }
   
   nPrincipal = 0.0;
   prin = 0.0;
   intrate = nIntRate / 100;
   period = nTerm;
   instal = nInstalment;
   yearlycompoundings = intarr1[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr1[ oCombo2.getSelectedIndex()  ]; // No. of instalements per annum
   m = 0.0;
   fulcomp = 0.0;
   balacomp = 0.0;
   total1 = 0.0;
   x = 0.0;
   l = 0.0;
   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlyinstalments; // rate per yearlyinstalments
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ) ; //Full Compounding Period
      balacomp = period - (fulcomp / yearlycompoundings * yearlyinstalments); // Balance Compounding Period
      total1 = 0.0;
      x = yearlyinstalments / yearlycompoundings;
      l = ( x + ( x * ( x - 1 ) / 2 * m ) ) / ( 1 + ( intrate / yearlycompoundings ) );
      if ( balacomp > 0 )
      {
         m1 = (balacomp + ( ( balacomp * ( balacomp - 1 ) / 2 ) * m ) ) / ( 1 + ( m * balacomp ) ) / Math.pow( ( 1 + ( intrate / yearlycompoundings ) ), fulcomp );
         total1 = total1 + m1;
      }   
      if ( fulcomp > 0 )
      {
         total1 = total1 + l;
      }   
		for ( i = 2; i <= fulcomp; i++) 
      {
          l = l / ( 1 + ( intrate / yearlycompoundings ) );
          total1 = total1 + l;
      }   
      prin = total1 * instal;
      prin = prin.toFixed( 2 );
      oTextBox1.setValue( ( prin ).toString() );
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      m = intrate / yearlycompoundings; // rate per compounding period
      n = ( yearlycompoundings / yearlyinstalments );
      counter = 1
      l = 1
      total1 = 0.0
      for ( counter = 1; counter <= period; counter++ )
      {
         l = l / ( Math.pow( ( 1 + m ), n ) );
         total1 = total1 + l;
      }   
      prin = total1 * instal;
      prin = prin.toFixed( 2 );
      oTextBox1.setValue( ( prin ).toString() );
   }
   showloanaccount();
}

function loan_intrate()
{
   prin = parseFloat( oTextBox1.getValue() );
   intrate = 0.0;
   period = parseFloat( oTextBox3.getValue() );
   instal = parseFloat( oTextBox4.getValue() );
   intarr1 = [ 12, 4, 2, 1 ];
   yearlycompoundings = intarr1[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr1[ oCombo2.getSelectedIndex()  ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox1.isValid() ) 
   {
      alert( 'Principal should be correctly entered!' );
      document.getElementById( oTextBox1.getId() ).select();
      return;
   }
      
   if ( !oTextBox3.isValid() ) 
   {
      alert( 'Term should be correctly entered!' );
      document.getElementById( oTextBox3.getId() ).select();
      return;
   }
      
   if ( !oTextBox4.isValid() ) 
   {
      alert( 'Instalment should be correctly entered!' );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }
   
   if ( period * instal < prin )
   {
      alert( "The total instalments payable can not be below the principal value!!!" );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }
   if ( yearlyinstalments >= yearlycompoundings )
   {
      fulcomp = parseInt( period / (yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
      balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      intrate = 0.00001;
      crossed = false;
      centpercentwarn = false;
      while ( !crossed )
      {
         total1 = 0.0;
         m = intrate / yearlyinstalments; // rate per yearlyinstalments
         x = yearlyinstalments / yearlycompoundings;
         l = ( x + ( x * ( x - 1 ) / 2 * m ) ) / ( 1 + ( intrate / yearlycompoundings ) );
         if ( balacomp > 0 )
         {
            m1 = ( balacomp + ( ( balacomp * ( balacomp - 1 ) / 2 ) * m ) ) / ( 1 + ( m * balacomp ) ) / Math.pow( ( 1 + ( intrate / yearlycompoundings ) ), fulcomp );
            total1 = total1 + m1;
         }   
         if ( fulcomp > 0 )
         {
            total1 = total1 + l;
         }   
         for( i = 2; i <= fulcomp; i++ )
         {
            l = l / ( 1 + ( intrate / yearlycompoundings ) );
             total1 = total1 + l;
         }   
         if ( ( total1 * instal ) - prin  < 0.0 )
         {
            crossed = true;
//            if ( centpercentwarn )
//               interest.statusBar.item(1) := "Caution. Interest Rate goes beyond 100%! "+str(intrate*100,9,4)
//            else
//               interest.statusBar.item(1) := ""
//            endif
         }
         else
         {
            if ( ( ( total1*instal ) - prin ) / prin > 0.01 )
            { 
               intrate = intrate + 0.0001;
            }   
            else
            {
               intrate = intrate + 0.00001;
            }   
            if ( ( intrate > 1 ) && ( !centpercentwarn ) )
            {
               centpercentwarn = true;
            }   
         }   
      }   
      intrate = ( intrate * 100 ).toFixed( 2 );
      oTextBox2.setValue( ( intrate ).toString() );
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      n = ( yearlycompoundings / yearlyinstalments );
      intrate = 0.00001;
      crossed = false;
      centpercentwarn = false;
      while ( !crossed )
      {
         counter = 1;
         l = 1;
         m = intrate / yearlycompoundings;// rate per compounding period
         total1 = 0.0;
         while ( counter <= period )
         {
            l = l / Math.pow( ( 1 + m ), n )
            total1 = total1 + l;
            counter = counter + 1;
         }
         if ( ( total1 * instal ) - prin  < 0.0 )
         {
            crossed = true;
         }   
         else
         {
            if ( ( ( total1 * instal ) - prin ) / prin > 0.01 )
            {
               intrate = intrate + 0.0001;
            }   
            else
            {
               intrate = intrate + 0.00001;
            }   
         }   
         if ( ( intrate > 1 ) && ( !centpercentwarn ) )
         {
            centpercentwarn = true;
         }
      }   
      intrate = ( intrate * 100 ).toFixed( 2 );
      oTextBox2.setValue( ( intrate ).toString() );
   }   
   showloanaccount();
}

function loan_term()
{
   prin = parseFloat( oTextBox1.getValue() );
   intrate = parseFloat( oTextBox2.getValue() / 100 );
   period = 0;
   instal = parseFloat( oTextBox4.getValue() );
   intarr1 = [ 12, 4, 2, 1 ];
   yearlycompoundings = intarr1[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr1[ oCombo2.getSelectedIndex()  ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox1.isValid() ) 
   {
      alert( 'Principal should be correctly entered!' );
      document.getElementById( oTextBox1.getId() ).select();
      return;
   }
      
   if ( !oTextBox2.isValid() ) 
   {
      alert( 'Interest Rate should be correctly entered!' );
      document.getElementById( oTextBox2.getId() ).select();
      return;
   }
      
   if ( !oTextBox4.isValid() ) 
   {
      alert( 'Instalment should be correctly entered!' );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }
   
   if ( prin < instal )
   {
      alert( "Principal amount must be greater than Instalment amount." );
      return;
   }   
   
   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlyinstalments; // rate per yearlyinstalments
      if ( ( prin * m ) >= instal )
      {
         alert( "The instalment amount is not enough even to cover the interest portion!" );
         return;
      }   
      period = prin / instal;
      crossed = false;
      x = yearlyinstalments / yearlycompoundings;
      while ( !crossed )
      {
         l = ( x + ( x * ( x - 1 ) / 2 * m ) ) / ( 1 + ( intrate / yearlycompoundings ) );
         fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
         balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
         total1 = 0.0;
         if ( balacomp > 0 )
         {
            m1 = ( balacomp + ( ( balacomp * ( balacomp - 1 ) / 2 ) * m ) ) / ( 1 + ( m * balacomp ) ) / Math.pow( ( 1 + ( intrate / yearlycompoundings ) ), fulcomp );
            total1 = total1 + m1;
         }   
         if ( fulcomp > 0 )
         {
            total1 = total1 + l;
         }
         for( i = 2; i <= fulcomp; i++ )
         {
            l = l / ( 1 + ( intrate / yearlycompoundings ) );
            total1 = total1 + l;
         }   
         if ( ( total1 * instal ) -  prin  > 0.0 )
         {
            crossed = true;
         }   
         else
         {
            period = period + 1;
         }   
      }   
      period = ( period ).toFixed( 0 );
      oTextBox3.setValue( ( period ).toString() );
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      n = (yearlycompoundings/yearlyinstalments);
      m = intrate / yearlycompoundings;// rate per compounding period
      interest = 0.0;
      balance = prin;
      for( i = 1; i <= n; i++ )
      {
         interest = interest + ( balance * m );
         balance = prin + interest;
      }
      if ( instal <= interest )
      {
         alert( "The instalment amount is not enough even to cover the interest portion!" );
         return;
      }   
      period = prin / instal;
      crossed = false;
      while ( !crossed )
      {
         counter = 1;
         l = 1;
         total1 = 0.0;
         while ( counter <= period )
         {
            l = l / Math.pow( ( 1 + m ), n );
            total1 = total1 + l;
            counter = counter + 1;
         }   
         if ( ( total1 * instal ) - prin  > 0.0 )
         {
            crossed = true;
         }   
         else
         {
            period = period + 1;
         }   
      }   
      period = ( period ).toFixed( 0 );
      oTextBox3.setValue( ( period ).toString() );
   }   
   showloanaccount();
}

function loan_instalment()
{
   prin = parseFloat( oTextBox1.getValue() );
   intrate = parseFloat( oTextBox2.getValue() / 100 );
   period = parseFloat( oTextBox3.getValue() );
   instalments = 0.0;
   intarr1 = [ 12, 4, 2, 1 ];
   yearlycompoundings = intarr1[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr1[ oCombo2.getSelectedIndex()  ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox1.isValid() ) 
   {
      alert( 'Principal should be correctly entered!' );
      document.getElementById( oTextBox1.getId() ).select();
      return;
   }
      
   if ( !oTextBox2.isValid() ) 
   {
      alert( 'Interest Rate should be correctly entered!' );
      document.getElementById( oTextBox2.getId() ).select();
      return;
   }
      
   if ( !oTextBox3.isValid() ) 
   {
      alert( 'Period should be correctly entered!' );
      document.getElementById( oTextBox3.getId() ).select();
      return;
   }

   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlyinstalments; // rate per yearlyinstalments
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
      balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      total1 = 0.0;
      x = yearlyinstalments / yearlycompoundings;
      l = ( x + ( x * ( x - 1 ) / 2 * m ) ) / ( 1 + ( intrate / yearlycompoundings ) );
      if ( balacomp > 0 )
      {
         m1 = ( balacomp + ( ( balacomp * ( balacomp - 1 ) / 2 ) * m ) ) / ( 1 + ( m * balacomp ) ) / Math.pow( ( 1 + ( intrate / yearlycompoundings ) ), fulcomp );
         total1 = total1 + m1;
      }   
      if ( fulcomp > 0 )
      {
         total1 = total1 + l;
      }
      for( i = 2; i <= fulcomp; i++ )
      {
         l = l / ( 1 + ( intrate / yearlycompoundings ) );
         total1 = total1 + l;
      }   
      instal = prin / total1;
      instal = ( instal ).toFixed( 2 );
      oTextBox4.setValue( ( instal ).toString() )
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      m = intrate / yearlycompoundings; // rate per compounding period
      n = ( yearlycompoundings / yearlyinstalments );
      counter = 1;
      l = 1;
      total1 = 0.0;
      while( counter <= period )
      {
         l =  l / Math.pow( ( 1 + m ), n )
         total1 = total1 + l;
         counter = counter + 1;
      }   
      instal = prin / total1;
      instal = ( instal ).toFixed( 2 );
      oTextBox4.setValue( ( instal ).toString() )
   }   
   showloanaccount();
}

function showloanaccount()
{
   prin = parseFloat( oTextBox1.getValue() );
   intrate = parseFloat( oTextBox2.getValue() ) / 100;
   period = parseFloat( oTextBox3.getValue() );
   roundby = 2;
   instal = parseFloat( oTextBox4.getValue() );
   intarr1 = [ 12, 4, 2, 1 ];
   termarr1 = [ "Month", "Quarter", "Half Year", "Year" ];
   yearlycompoundings = intarr1[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr1[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   total1 = 0.0;
   total2 = 0.0;
   count = oGrid1.getRowCount();
   for( i = count - 1; i > 0; i-- )
   {
      oGrid1.deleteRow( i );
   }
   reportarr = [];
   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlyinstalments; // rate per yearlyinstalments
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) );  //Full Compounding Period
      balacomp = period - (fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      oGrid1.setCell( 0, 1, termarr1[ oCombo2.getSelectedIndex() ] );
      counter = 1;
      count1 = 1;
      balance = prin;
      totint = 0;
      totinst = 0;
      product = 0;
      interest = 0;
      while ( counter <= period )
      {
         totinst = totinst + instal;
         product = product + balance;
         if ( counter % ( yearlyinstalments / yearlycompoundings ) == 0 )
         {
            interest = ( product * m );
            totint = interest + totint;
            product = 0.0;
         }   
         if ( counter > ( fulcomp / yearlycompoundings * yearlyinstalments ) )
         {
            product = 0;
            totinst = totinst - instal;
            while ( count1 <= balacomp )
            {
               totinst = totinst + instal;
               product = product + balance;
               if ( counter == period )
               {
                  interest = ( product * m );
                  totint = interest + totint;
                  product = 0;
               }   
               oGrid1.addRow( [ ( counter ).toFixed( 0 ).toString(),
                                ( balance ).toFixed( roundby ).toString(),
                                ( interest ).toFixed( roundby ).toString(),
                                ( instal ).toFixed( roundby ).toString(),
                                ( balance + interest - instal ).toFixed( roundby ).toString() ] );
               balance = balance + interest - instal;
               count1 = count1 + 1;
               counter = counter + 1;
               interest = 0;
            }   
         }   
         if ( counter <= ( fulcomp / yearlycompoundings * yearlyinstalments ) )
         {
            oGrid1.addRow( [ ( counter ).toFixed( 0 ).toString(),
                             ( balance ).toFixed( roundby ).toString(),
                             ( interest ).toFixed( roundby ).toString(),
                             ( instal ).toFixed( roundby ).toString(),
                             ( balance + interest - instal ).toFixed( roundby ).toString() ] );
            balance = balance + interest - instal;
            counter = counter + 1;
            interest = 0;
         }   
      }   
//   total1 = 0.0;
//   total2 = 0.0;
//    total1 = total1 + reportarr[i,3] ;
//      total2 = total2 + reportarr[i,4];
   }
   if ( yearlyinstalments < yearlycompoundings )
   {
      m = intrate / yearlycompoundings;  // rate per compounding period
      n1 = ( yearlycompoundings / yearlyinstalments );
      oGrid1.setCell( 0, 1, termarr1[ oCombo1.getSelectedIndex() ] );
      counter = 1;
      count1 = 1;
      instal1 = 0.0;
      balance = prin;
      totint = 0.0;
      totinst = 0.0;
      product = 0.0;
      interest = 0.0;
      comcount = 1;
      inscount = 1;
      while ( counter <= ( period * yearlycompoundings / yearlyinstalments ) )
      {
         product = balance + product;
         interest = ( product * m );
         totint = totint + interest;
         product = 0.0;
         if ( inscount == n1 )
         {
            instal1 = instal;
            totinst = totinst + instal1;
            inscount = 0;
         }   
         else
         {
            instal1 = 0;
         }
         oGrid1.addRow( [ ( counter ).toFixed( 0 ).toString(),
                 ( balance ).toFixed( roundby ).toString(),
                 ( interest ).toFixed( roundby ).toString(),
                 ( instal1 ).toFixed( roundby ).toString(),
                 ( balance + interest - instal1 ).toFixed( roundby ).toString() ] );
         balance = balance + interest - instal1;
         counter = counter + 1;
         inscount = inscount + 1;
         interest = 0;
      }   
//   total1 = 0.0;
//   total2 = 0.0;
//      total1 := total1 + reportarr[i,3]
//      total2 := total2 + reportarr[i,4]
   }

   oGrid1.setJustify( [ 'right', 'right', 'right', 'right', 'right' ] );

}