//recurring deposit section

function recurring_deposit()
{
   oWin       = new Form    ( "Recurring Deposit Section", 700, 500);
   oLabel1    = new Label   ( oWin, 30, 10, "Interest Compounding" );
   oCombo1    = new ComboBox( oWin, 30, 200, [ "Daily", "Monthly", "Quarterly", "Half yearly", "Yearly" ],  [ "Daily", "Monthly", "Quarterly", "Half yearly", "Yearly" ],
                                  0 );
   oTextBox1  = new TextBox ( oWin, 70, 200, '' );
   oTextBox2  = new TextBox ( oWin, 110, 200, '' );
   oLabel2    = new Label   ( oWin, 110, 360, '% p.a.' );
   oTextBox3  = new TextBox ( oWin, 150, 200, '' );
   oCombo2    = new ComboBox( oWin, 150, 360, 
                                  [ "Days", "Months", "Quarters", "Half Years", "Years" ],
                                  [ "Days", "Months", "Quarters", "Half Years", "Years" ],
                                  0 );
   oTextBox4  = new TextBox ( oWin, 190, 200, '' );
   oButton1   = new Button  ( oWin, 70, 10, 'Deposit Amount', "rd_principal()" );
   oButton2   = new Button  ( oWin, 110, 10, 'Interest Rate', "rd_intrate()" );
   oButton3   = new Button  ( oWin, 150, 10, 'Term', "rd_term()" );
   oButton4   = new Button  ( oWin, 190, 10, 'Maturity Value', "rd_maturity()" );
   oGrid1     = new Grid    ( oWin, 230, 10, 680, 210, [ "     ", "Opening Balance", "Investment", "Total", "Interest", "Closing Balance" ], 640 );
   oButton5   = new Button  ( oWin, 450, 150, "Close", "oWin.release()" );
   oButton6   = new Button  ( oWin, 450, 300, "Reset", "rdreset()" );
   
   oTextBox1.setJustify( 'right' );
   oTextBox2.setJustify( 'right' );
   oTextBox3.setJustify( 'right' );
   oTextBox4.setJustify( 'right' );
   
   oTextBox1.setNumericMask( 14, 2, '.', '', false );
   oTextBox2.setNumericMask( 3, 2, '.', '', false );
   oTextBox3.setNumericMask( 5, 0, '.', '', false );
   oTextBox4.setNumericMask( 14, 2, '.', '', false );
   

}

function rdreset()
{
   oTextBox1.setValue( '' );
   oTextBox2.setValue( '' );
   oTextBox3.setValue( '' );
   oTextBox4.setValue( '' );
   count = oGrid1.getRowCount();
   for( i = count - 1; i > 0; i-- )
   {
      oGrid1.deleteRow( i );
   }
   document.getElementById( oTextBox1.getId() ).select()
}

function rd_principal()
{
   instal      = 0.0;
   intrate     = parseFloat( oTextBox2.getValue() ) / 100;
   period      = parseFloat( oTextBox3.getValue() );
   maturity    = parseFloat( oTextBox4.getValue() );
   intarr2 = [ 360, 12, 4, 2, 1 ];
   yearlycompoundings = intarr2[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr2[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox2.isValid() ) 
   {
      alert( 'Interest Rate should be correctly entered!' );
      document.getElementById( oTextBox2.getId() ).select();
      return;
   }
      
   if ( !oTextBox3.isValid() ) 
   {
      alert( 'Term should be correctly entered!' );
      document.getElementById( oTextBox3.getId() ).select();
      return;
   }
      
   if ( !oTextBox4.isValid() ) 
   {
      alert( 'Maturity Value should be correctly entered!' );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }

   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlyinstalments; // rate per yearlyinstalments
      total1 = 0.0;
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
      balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      if ( fulcomp > 0 )
      {
         n = yearlyinstalments / yearlycompoundings;
         l = n  + ( ( ( n * ( n + 1 ) ) / 2 ) * (intrate / yearlyinstalments));
         total1 = l;
         for ( i = 2; i <= fulcomp; i++ )
         {
            total1 = ( total1 * ( 1 + ( intrate / yearlycompoundings ) ) ) + l;
         }
      }
      total1 = ( total1 * ( 1 + ((intrate / yearlyinstalments) * balacomp) ) ) + balacomp + ( ( ( balacomp * ( balacomp + 1 ) ) / 2 ) * ( intrate / yearlyinstalments ) );
      instal = maturity / total1;
      instal = ( instal ).toFixed( 2 );
      oTextBox1.setValue( ( instal ).toString() )
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      m = intrate / yearlycompoundings;
      total1 = Math.pow( ( 1 + m ), ( yearlycompoundings / yearlyinstalments ) );
      for ( i = 2; i <= period; i++ )
      {
         total1 = total1 + 1;
         total1 = ( total1 * Math.pow( ( 1 + m ), ( yearlycompoundings / yearlyinstalments ) ) );
      }   
      instal = maturity / total1;
      instal = ( instal ).toFixed( 2 );
      oTextBox1.setValue( ( instal ).toString() )
   }
   showrdaccount()
}

function rd_intrate()
{
   instal      = parseFloat( oTextBox1.getValue() );
   intrate     = 0.0; 
   period      = parseFloat( oTextBox3.getValue() );
   maturity    = parseFloat( oTextBox4.getValue() );
   intarr2 = [ 360, 12, 4, 2, 1 ];
   yearlycompoundings = intarr2[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr2[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox1.isValid() ) 
   {
      alert( 'Deposit Amount should be correctly entered!' );
      document.getElementById( oTextBox1.getId() ).select();
      return;
   }
      
   if ( !oTextBox3.isValid() ) 
   {
      alert( 'Term should be correctly entered!' );
      document.getElementById( oTextBox3.getId() ).select();
      return;
   }
      
   if ( !oTextBox4.isValid() ) 
   {
      alert( 'Maturity Value should be correctly entered!' );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }

   if ( ( instal * period ) >= maturity )
   {
      alert( "Maturity value MUST be greater than amount invested." );
      return;
   }
   if ( yearlyinstalments >= yearlycompoundings )
   {
      intrate = 0.00001;
      crossed = false;
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
      balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      n = yearlyinstalments / yearlycompoundings;
      while ( !crossed )
      {
         m = intrate / yearlyinstalments; // rate per yearlyinstalments
         total1 = 0.0;
         if ( fulcomp > 0 )
         {
            l = n  + ( ( ( n * ( n + 1 ) ) / 2 ) * ( intrate / yearlyinstalments ) );
            total1 = l;
            for ( i = 2; i <= fulcomp; i++ )
            {
               total1 = ( total1 * ( 1 + ( intrate / yearlycompoundings ) ) ) + l;
            }
         }   
         total1 = ( total1 * ( 1 + ( ( intrate / yearlyinstalments ) * balacomp ) ) ) + balacomp + ( ( ( balacomp * ( balacomp + 1 ) ) / 2 ) * ( intrate / yearlyinstalments ) );
         if ( ( total1 * instal ) >= maturity )
         {
            crossed = true;
         }   
         else
         {
            if ( maturity - ( total1 * instal ) > 1000 )
            {
               intrate = intrate + 0.0001;
            }   
            else
            {
               intrate = intrate + 0.00001;
            }   
         }
      }
      intrate = ( intrate * 100 ).toFixed( 2 );
      oTextBox2.setValue( ( intrate ).toString() );
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      intrate = 0.00001;
      crossed = false;
      x = ( yearlycompoundings / yearlyinstalments );
      while ( !crossed )
      {
         m = intrate / yearlycompoundings;
         total1 = Math.pow( ( 1 + m ), x );
         for ( i = 2; i <= period; i++ )
         {
            total1 = total1 + 1;
            total1 = ( total1 * Math.pow( ( 1 + m ), x ) );
         }   
         if ( ( total1 * instal ) >= maturity )
         {
            crossed = true;
         }   
         else
         {
            if ( maturity - ( total1 * instal ) > 1000 )
            {
               intrate = intrate + 0.0001;
            }   
            else
            {
               intrate = intrate + 0.00001;
            }
         }      
      }   
      intrate = ( intrate * 100 ).toFixed( 2 );
      oTextBox2.setValue( ( intrate ).toString() );
   }   
   showrdaccount()
}

function rd_term()
{
   instal      = parseFloat( oTextBox1.getValue() );
   intrate     = parseFloat( oTextBox2.getValue() ) / 100;
   period      = 0;
   maturity    = parseFloat( oTextBox4.getValue() );
   intarr2 = [ 360, 12, 4, 2, 1 ];
   yearlycompoundings = intarr2[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr2[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox1.isValid() ) 
   {
      alert( 'Deposit Amount should be correctly entered!' );
      document.getElementById( oTextBox1.getId() ).select();
      return;
   }
   
   if ( !oTextBox2.isValid() ) 
   {
      alert( 'Interest Rate should be correctly entered!' );
      document.getElementById( oTextBox2.getId() ).select();
      return;
   }
      
      
   if ( !oTextBox4.isValid() ) 
   {
      alert( 'Maturity Value should be correctly entered!' );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }

   if ( instal >= maturity )
   {
      alert( "Maturity value MUST be greater than instalment amount!" );
      return;
   }
   if ( yearlyinstalments >= yearlycompoundings )
   {
      period = 1;
      crossed = false;
      m = intrate / yearlyinstalments; // rate per yearlyinstalments
      n = yearlyinstalments / yearlycompoundings;
      while ( !crossed )
      {
         fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
         balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
         total1 = 0.0;
         if ( fulcomp > 0 )
         {
            l = n  + ( ( ( n * ( n + 1 ) ) / 2 ) * ( intrate / yearlyinstalments ) );
            total1 = l;
            for ( i = 2; i <= fulcomp; i++ )
            {
               total1 = ( total1 * ( 1 + ( intrate / yearlycompoundings ) ) ) + l;
            }   
         }   
         total1 = ( total1 * ( 1 + ( ( intrate / yearlyinstalments ) * balacomp ) ) ) + balacomp + ( ( ( balacomp * ( balacomp + 1 ) ) / 2 ) * ( intrate / yearlyinstalments ) )
         if ( ( total1 * instal ) >= maturity )
         {
            crossed = true;
         }   
         else
         {
            period = period + 1;
         }   
      }   
      period = ( period ).toFixed( 0 );
      oTextBox3.setValue( ( period ).toString() );
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      period = 1;
      crossed = false;
      x = ( yearlycompoundings / yearlyinstalments );
      while ( !crossed )
      {
         m = intrate / yearlycompoundings;
         total1 = Math.pow( ( 1 + m ), x );
         for ( i = 2; i <= period; i++ )
         {
            total1 = total1 + 1;
            total1 = ( total1 * Math.pow( ( 1 + m ), x ) );
         }   
         if ( ( total1 * instal ) >= maturity )
         {
            crossed = true;
         }   
         else
         {
            period = period + 1;
         }
      }
      period = ( period ).toFixed( 0 );
      oTextBox3.setValue( ( period ).toString() );
   }   
   showrdaccount()
}

function rd_maturity()
{
   instal      = parseFloat( oTextBox1.getValue() );
   intrate     = parseFloat( oTextBox2.getValue() ) / 100;
   period      = parseFloat( oTextBox3.getValue() );
   maturity    = 0.0
   intarr2 = [ 360, 12, 4, 2, 1 ];
   yearlycompoundings = intarr2[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr2[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   m = 0.0;
   if ( !oTextBox1.isValid() ) 
   {
      alert( 'Deposit Amount should be correctly entered!' );
      document.getElementById( oTextBox1.getId() ).select();
      return;
   }
   
   if ( !oTextBox2.isValid() ) 
   {
      alert( 'Interest Rate should be correctly entered!' );
      document.getElementById( oTextBox2.getId() ).select();
      return;
   }
      
      
   if ( !oTextBox3.isValid() ) 
   {
      alert( 'Term should be correctly entered!' );
      document.getElementById( oTextBox4.getId() ).select();
      return;
   }

   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlyinstalments; // rate per yearlyinstalments
      total1 = 0.0;
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
      balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      if ( fulcomp > 0 )
      {
         n = yearlyinstalments / yearlycompoundings;
         l = n  + ( ( ( n * ( n + 1 ) ) / 2 ) * ( intrate / yearlyinstalments ) );
         total1 = l;
         for ( i = 2; i <= fulcomp; i++ )
         {
            total1 = ( total1 * ( 1 + ( intrate / yearlycompoundings ) ) ) + l;
         }   
      }   
      total1 = ( total1 * ( 1 + ( ( intrate / yearlyinstalments ) * balacomp ) ) ) + balacomp + ( ( ( balacomp * ( balacomp + 1 ) ) / 2 ) * ( intrate / yearlyinstalments ) );
      maturity = total1 * instal;
      maturity = ( maturity ).toFixed( 2 );
      oTextBox4.setValue( ( maturity ).toString() );
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      m = intrate / yearlycompoundings;
      total1 = Math.pow( ( 1 + m ), ( yearlycompoundings / yearlyinstalments ) );
      for ( i = 2; i <= period; i++ )
      {
         total1 = total1 + 1;
         total1 = ( total1 * Math.pow( ( 1 + m ), ( yearlycompoundings / yearlyinstalments ) ) );
      }   
      maturity = total1 * instal;
      maturity = ( maturity ).toFixed( 2 );
      oTextBox4.setValue( ( maturity ).toString() );
   }   
   showrdaccount()
}


function showrdaccount()
{
   intarr2 = [ 360, 12, 4, 2, 1 ];
   termarr1 = [ "Day", "Month", "Quarter", "Half Year", "Year" ];
   instal      = parseFloat( oTextBox1.getValue() );
   intrate     = parseFloat( oTextBox2.getValue() ) / 100;
   period      = parseFloat( oTextBox3.getValue() );
   maturity    = parseFloat( oTextBox4.getValue() );
   roundby = 2;
   yearlycompoundings = intarr2[ oCombo1.getSelectedIndex() ]; // No. of interest compounding per annum
   yearlyinstalments = intarr2[ oCombo2.getSelectedIndex() ]; // No. of instalements per annum
   total1 = 0.0;
   total2 = 0.0;
   count = oGrid1.getRowCount();
   for( i = count - 1; i > 0; i-- )
   {
      oGrid1.deleteRow( i );
   }
   if ( yearlyinstalments >= yearlycompoundings )
   {
      m = intrate / yearlyinstalments;// rate per yearlyinstalments
      fulcomp = parseInt( period / ( yearlyinstalments / yearlycompoundings ) ); //Full Compounding Period
      balacomp = period - ( fulcomp / yearlycompoundings * yearlyinstalments ); // Balance Compounding Period
      oGrid1.setCell( 0, 1, termarr1[ oCombo1.getSelectedIndex() ] );
      counter = 1;
      count1 = 1;
      balance = 0.0;
      totint = 0;
      totinst = 0;
      product = 0;
      interest = 0;
      while ( counter <= period )
      {
         product = product + balance + instal;
         totinst = totinst + instal;
         if ( ( counter % ( yearlyinstalments / yearlycompoundings ) ) == 0 )
         {
            interest = product * m;
            totint = interest + totint;
            product = 0.0;
         }
         if ( counter > ( fulcomp / yearlycompoundings * yearlyinstalments ) )
         {
            product = 0;
            while ( count1 <= balacomp )
            {
               product = product + balance + instal;
               if ( counter == period )
               {
                  interest = product * m;
                  totint = interest + totint;
                  product = 0;
               }   
               oGrid1.addRow( [ ( counter ).toFixed( 0 ).toString(),
                       ( balance ).toFixed( roundby ).toString(),
                       ( instal ).toFixed( roundby ).toString(),
                       ( balance + instal ).toFixed( roundby ).toString(),
                       ( interest ).toFixed( roundby ).toString(),
                       ( balance + instal + interest ).toFixed( roundby ).toString() ] );
               balance = balance + interest + instal;
               count1 = count1 + 1;
               counter = counter + 1;
               interest = 0.0;
            }   
         }
         if ( counter <= ( fulcomp / yearlycompoundings * yearlyinstalments ) )
         {
            oGrid1.addRow( [ ( counter ).toFixed( 0 ).toString(),
                    ( balance ).toFixed( roundby ).toString(),
                    ( instal ).toFixed( roundby ).toString(),
                    ( balance + instal ).toFixed( roundby ).toString(),
                    ( interest ).toFixed( roundby ).toString(),
                    ( balance + instal + interest ).toFixed( roundby ).toString() ] );
            balance = balance + interest + instal;
            counter = counter + 1;
            interest = 0.0;
         }   
      }   
   }   
   if ( yearlyinstalments < yearlycompoundings )
   {
      m = intrate / yearlycompoundings;  // rate per compounding period
      n1 = ( yearlycompoundings / yearlyinstalments );
      oGrid1.setCell( 0, 1, termarr1[ oCombo1.getSelectedIndex() ] );
      counter = 1;
      count1 = 1;
      instal1 = 0.0;
      balance = 0.0;
      totint = 0.0;
      totinst = 0.0;
      product = 0.0;
      interest = 0.0;
      comcount = 1;
      inscount = 1;
      while ( counter <= ( period * yearlycompoundings / yearlyinstalments ) )
      {
         if ( ( inscount == n1 ) || ( counter == 1 ) )
         {
            instal1 = instal;
            totinst = totinst + instal1;
            inscount = 0;
         }   
         else
         {
            instal1 = 0.0;
         }   
         product = balance + product + instal1;
         interest = product * m;
         totint = totint + interest;
         product = 0.0;
         oGrid1.addRow( [ ( counter ).toFixed( 0 ).toString(),
                 ( balance ).toFixed( roundby ).toString(),
                 ( instal1 ).toFixed( roundby ).toString(),
                 ( balance + instal1 ).toFixed( roundby ).toString(),
                 ( interest ).toFixed( roundby ).toString(),
                 ( balance + instal1 + interest ).toFixed( roundby ).toString() ] );
         balance = balance + interest + instal1;
         counter = counter + 1;
         inscount = inscount + 1;
         interest = 0;
      }   
   }   
   oGrid1.setJustify( [ 'right', 'right', 'right', 'right', 'right', 'right' ] );

}  










function FlexGrid( oParent, nRow, nCol, nWidth, nHeight, aHeaders, nInnerWidth )
{

	var cId = 'control' + (nControlCount).toString() ; nControlCount++ ;

	// Create a scrollable div as container for the table.

	control = document.createElement( "div" )        ;

	panel = cId + '_panel';

	control.style.position = "absolute"                  ;
	control.style.top      = nRow                        ;
	control.style.left     = nCol                        ;
	control.style.width    = nWidth                      ;
	control.style.height   = nHeight                     ;
	control.id             = panel                       ;
	control.style.border   = "solid 1px rgb(200,200,200)"    ;
	control.style.overflow = "scroll"                    ;
    
	document.getElementById( oParent.getId() ).appendChild( control )                ;

        // creates a <table> element and a <tbody> element

        var tbl     = document.createElement("table");
        var tblBody = document.createElement("tbody");

	tbl.className = "flexgrid";

	// Headers

	var row = document.createElement("tr");

	var cell = document.createElement("th");
	var cellText = document.createTextNode( '#' );
	cell.appendChild(cellText);
	row.appendChild(cell);

	for( n = 0; n < aHeaders.length; n++ )
	{	
		var cell = document.createElement("th");
		var cellText = document.createTextNode( aHeaders [n] );
		cell.appendChild(cellText);
		row.appendChild(cell);
	}

	tblBody.appendChild(row);

	// End Headers

        tbl.setAttribute("border", "0");
        tbl.setAttribute("width", nInnerWidth );
        tbl.setAttribute("id", cId );

        tbl.appendChild(tblBody);

	control.appendChild( tbl )                ;

	// addRow Method ///////////////////////////////////////////////////////////////////////

	this.addRow = function( aRow )
	{
		var row = document.createElement("tr");

		var cell = document.createElement("td");
		var chkbox = document.createElement('input'); chkbox.type = "checkbox";
		chkbox.onclick = function() { changeState( this ); };
		cell.appendChild(chkbox)
		row.appendChild(cell);

		for( n = 0; n < aRow.length; n++ )
		{	
			var cell = document.createElement("td");
			var cellText = document.createTextNode( aRow [n] );
			cell.appendChild(cellText);
			row.appendChild(cell);
		}

		tblBody.appendChild(row);
	}



	// getRowCount Method //////////////////////////////////////////////////////////////////

	this.getRowCount = function()
	{
		return document.getElementById(cId).rows.length;
	}

	// getCell Method //////////////////////////////////////////////////////////////////////

	this.getCell = function( nRow , nCOl )
	{
		return document.getElementById(cId).rows[nRow].cells[nCOl].childNodes[0].data;
	}

	// setCell Method //////////////////////////////////////////////////////////////////////

	this.setCell = function( nRow , nCOl , cValue )
	{
		document.getElementById(cId).rows[nRow].cells[nCOl].childNodes[0].data = cValue ;
	}

	// select Method ///////////////////////////////////////////////////////////////////////

	this.select = function( nRow )
	{
		document.getElementById(cId).rows[nRow].cells[0].getElementsByTagName("input")[0].checked = true ;
		changeState( document.getElementById(cId).rows[nRow].cells[0].getElementsByTagName("input")[0] );
	}

	// unSelect Method /////////////////////////////////////////////////////////////////////

	this.unSelect = function( nRow )
	{
		document.getElementById(cId).rows[nRow].cells[0].getElementsByTagName("input")[0].checked = false ;
		changeState( document.getElementById(cId).rows[nRow].cells[0].getElementsByTagName("input")[0] );
	}

	// deleteRow ///////////////////////////////////////////////////////////////////////////

	this.deleteRow = function( nRow )
	{
		document.getElementById( cId ).deleteRow(nRow);
	}

	// getId Method ////////////////////////////////////////////////////////////////////////

	this.getId = function ()
	{
		return cId;		
	}

	// getSelectedRows /////////////////////////////////////////////////////////////////////

	this.getSelectedRows = function()
	{
		var selectedRows=new Array();
		var i, code, first, last, n ;

		n = 0 ;

		for ( i=1 ; i < document.getElementById(cId).rows.length ; i++ )
		{
			if ( document.getElementById(cId).rows[i].cells[0].getElementsByTagName("input")[0].checked == true ) 
			{
				selectedRows[n] = i ;
				n++ ;
			}			 
		}
		return selectedRows;
	};

	// getSelectedRowCount Method //////////////////////////////////////////////////////////

	this.getSelectedRowCount = function()
	{
		var i, n ;

		n = 0 ;

		for ( i=1 ; i < document.getElementById(cId).rows.length ; i++ )
		{
			if ( document.getElementById(cId).rows[i].cells[0].getElementsByTagName("input")[0].checked == true ) 
			{
				n++ ;
			}			 
		}
		return n;
	};

}   
